#ifndef KYLIE_H
#define KYLIE_H

/* <scheme>://<net_loc>/<path>;<params>?<query>#<fragment> */

typedef struct object_box {
        int type;
        void *data;
	int min_w, max_w;
        int x, y, w, h;
	struct object_box *parent;
	struct object_box *child;	/* first child */
	struct object_box *last;	/* last child */
        struct object_box *next;
} object_box;

typedef struct url_components {
	char *scheme;
	char *net_loc;
	char *path;
	char *params;
	char *query;
	char *fragment;
} url_components;

typedef struct url_info {
	char *url;	/* normalized url */
	char *header;
	char *local;	/* cached file */
	int size;	/* excluding header */
	int ref;	/* for reference counting */
	struct url_info *next;
} url_info;

extern void free_url(url_info *);	/* io.c */
extern url_info *load_url(char *);		/* io.c */
extern url_info *load_http(char *);        /* http.c */
extern url_info *load_file(char *);        /* file.c */
extern url_info *load_about(char *);        /* file.c */
extern url_info *load_ftp(char *);      /* to be implemented */

#endif	/* KYLIE_H */
